#include <DallasTemperature.h>
#include <OneWire.h>
#include <IRremote.h>
#include <LiquidCrystal_I2C.h>
#include <Wire.h>
#include <SD.h>
#include <SPI.h>
#include <dht11.h>

#define ds18b20 8
#define IrPin 7
#define doorController 3
#define led 2 
#define pir 9
#define reprak 10

const int chipSelect = 53; 
int kolo = 1;
int dht11Temperature = 0;
int dht11Humidity = 0;
int dsTemperature = 0;
bool ledSviti = 0;
bool ovladac = 0;
bool ledInfo = 0;
bool alarmOn = 0;
bool door = 0;

OneWire oneWire_in(ds18b20);
DallasTemperature dsSensor(&oneWire_in);
IRrecv rec(IrPin);
decode_results prijmuto;
LiquidCrystal_I2C lcd(0x27,20,4); 
dht11 cidlo;

void setup() {
pinMode(reprak, OUTPUT);
pinMode(pir, INPUT);
pinMode(IrPin, INPUT);
pinMode(doorController, INPUT);
pinMode(led, OUTPUT);

dsSensor.begin();
Serial.begin(9600);
rec.enableIRIn();
SD.begin(chipSelect);
lcd.init();
lcd.backlight();
lcd.print("AHOJ :)");
if (SD.exists("teploty.txt")) { SD.remove("teploty.txt"); }
}

void loop() {
door = !digitalRead(doorController); // zavreno == 0
readDht11(6);
dsRead();


  // rožíhání led diod
  if (ovladac)
  {  
    if (ledSviti) { digitalWrite(led, !HIGH); ledInfo = 1;} else {digitalWrite(led, !LOW); ledInfo = 0; }
  }
  else
  {
   if (door) { digitalWrite(led, !HIGH); ledInfo = 1; } else {digitalWrite(led, !LOW); ledInfo = 0;}
  }
  
  if (rec.decode(&prijmuto)) 
  {
   translate();
   rec.resume(); 
  }
  
  // výpis dat
  writeData();
}


void translate()
{
  switch(prijmuto.value)
  {
  case 0xFF6897: ledSviti = 1;  break; // 1
  case 0xFF9867: ledSviti = 0; break; // 2
  case 0xFF42BD: ovladac = 0; break; // *
  case 0xFF52AD: ovladac = 1;    break; // #
  case 0xFF30CF: alarmOn = 1; break; // 4
  case 0xFF18E7: alarmOn = 0; break; // 5
  }
}

void startAlarm(int pauza, int frekvence)
{
 digitalWrite(led, HIGH);
 tone(reprak, frekvence);
 delay(pauza);
 
 digitalWrite(led, LOW);
 noTone(reprak);
 delay(pauza);
}


void readDht11(int pin)
{
 cidlo.read(pin);
 dht11Temperature = cidlo.temperature;
 dht11Humidity = cidlo.humidity;
}

void dsRead()
{
     dsSensor.requestTemperatures();
     dsTemperature = dsSensor.getTempCByIndex(0);
}


void writeData()
{
  kolo++;
  if ((kolo % 12) == 0)
  {
   String data = String(dht11Temperature) + "/" + String(dht11Humidity) + "/" + String(dsTemperature) + "/" + String(ledInfo);
   Serial.println(data);
   lcd.clear();
   lcd.print("doma: ");
   lcd.print(dht11Temperature);
   lcd.print((char)223);// znak °
   lcd.print("C");
   lcd.setCursor(0,1);
   lcd.print("vlhkost: ");
   lcd.print(dht11Humidity);
   lcd.print("%");
   lcd.setCursor(0,2);
   lcd.print("venku: ");
   lcd.print(dsTemperature);
   lcd.print((char)223);
   lcd.print("C");
   kolo = 0; 
   
   // ukládání na sd kartu
   File file = SD.open("teploty.txt", FILE_WRITE);
   if (file)
   {
    String textSD = "DHT11: " + String(dht11Temperature) + ((char)223) + "C" + "           " + "DS18B20: " + String(dsTemperature) + ((char)223) + "C";
    file.println(dht11Temperature);
    file.close(); 
   } 
  }
}

