﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.IO.Ports;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace machrCsharp_
{
    public partial class Form1 : Form
    {
        private SerialPort ctecka;
        private int dsTeplota;
        private int dht11Teplota;
        private int vlhkost;
        private int baudrate;
        private int dvere;
        private int diody;


        public Form1()
        {
            InitializeComponent();
            baudrate = 9600;
        }

        //nastavení čtení z arduina
        private void startButton_Click(object sender, EventArgs e)
        {
            portTimer.Enabled = true; // zapne čtení z portu
            infoLabel.Text = "";


            try
            {
                this.ctecka = new SerialPort("COM" + cisloPortuNum.Value);
                this.ctecka.DataReceived += new SerialDataReceivedEventHandler(DataReceivedHandler);
                this.ctecka.Open();
            }
            catch
            {
                MessageBox.Show("akci nelze provést. Zkontrolujte připojení");
            }

        }

        private void stopButton_Click(object sender, EventArgs e)
        {
            try
            {
                this.ctecka.Close();
            }
            catch
            {
               MessageBox.Show("Nespuštěné čtení nelze ukončit!");
            }
              portTimer.Enabled = false;
              infoLabel.Text = "NAMĚŘENÉ HODNOTY NEJSOU AKTUÁLNÍ!";
        }

         //čtení dat z portu
         private void DataReceivedHandler(
                      object sender,
                      SerialDataReceivedEventArgs e)

        {
            
            SerialPort sp = (SerialPort)sender;
            sp.BaudRate = this.baudrate;

            string precteno = sp.ReadExisting();

                String[] data = precteno.Split('/'); // uloží nasbíraná data do pole

                this.dht11Teplota = int.Parse(data[0]);
                this.vlhkost = int.Parse(data[1]);
                this.dsTeplota = int.Parse(data[2]);
                this.diody = int.Parse(data[3]);
           
                
        }

        // výpis nasbíraných dat
        private void portTimer_Tick(object sender, EventArgs e)
        {
            teplotaDht11Label.Text = Convert.ToString(this.dht11Teplota) + "°C";
            vlhkostLabel.Text = Convert.ToString(this.vlhkost) + "%";
            dsTempLabel.Text = Convert.ToString(this.dsTeplota) + "°C";
            if (this.diody == 1) { diodyLabel.Text = "ZAPNUTO"; } else { diodyLabel.Text = "VYPNUTO"; }
        }


    


   

     

       


    }
}
